<script>
	import { onMount } from 'svelte';
	import AutoComplete from 'simple-svelte-autocomplete';
	import { dashboardStation } from '$lib/preferences';
	import stationList from '/static/stationList.json';

	export let className = '';
	export let inputClassName = '';
	export let placeholder = '';

	let enableGeolocation = true;
	let selectedItem;

	const selectStation = () => {
		if (typeof selectedItem === 'undefined') return;

		dashboardStation.set(selectedItem);
		selectedItem = undefined;
	};

	const getClosestStation = (position) => {
		let distances = [];

		for (const station of stationList) {
			distances.push(
				Math.sqrt(
					(position.coords.latitude - station.latitude) ** 2 +
						(position.coords.longitude - station.longitude) ** 2
				)
			);
		}

		selectedItem = stationList[distances.indexOf(Math.min(...distances))];
		dashboardStation.set(selectedItem);
	};

	const getPosition = () => {
		navigator.geolocation.getCurrentPosition(getClosestStation, () => {
			console.error('Unable to retrieve your location');
		});
	};

	onMount(() => {
		enableGeolocation = navigator.geolocation;
	});
</script>

<div class="flex items-stretch w-full h-full">
	<AutoComplete
		items={stationList}
		labelFieldName="name"
		valueFieldName="id"
		maxItemsToShowInList="3"
		bind:selectedItem
		onChange={selectStation}
		hideArrow
		{className}
		{inputClassName}
		{placeholder}
	/>

	{#if enableGeolocation}
		<button on:click={getPosition}>Me localiser</button>
	{/if}
</div>
